package com.seeyon.apps.govdoc.dao;

import com.seeyon.apps.govdoc.po.GovdocLeaderPermissionRelation;
import com.seeyon.ctp.common.dao.BaseHibernateDao;
import com.seeyon.ctp.util.DBAgent;
import com.seeyon.ctp.util.FlipInfo;
import org.apache.logging.log4j.spi.LoggerRegistry;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GovdocDaiLuDao extends BaseHibernateDao<GovdocLeaderPermissionRelation> {
    public FlipInfo findLeaderAndPermissionRelation(FlipInfo flipInfo,Map params){
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where orgAccountId=:orgAccountId");
        DaiLuMap.put("orgAccountId",params.get("accountId"));
        
        if(params.get("leader")!= null) {
        	hql.append(" and leader like '%"+params.get("leader")+"%'");
        }
        hql.append(" order by createDate desc");
        
        List<GovdocLeaderPermissionRelation> datas = DBAgent.find(hql.toString(),DaiLuMap,flipInfo);
        flipInfo.setData(datas);
        return flipInfo;
    }
    public List<GovdocLeaderPermissionRelation> findById(Long id){
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where id=:id");
        DaiLuMap.put("id",id);
        return DBAgent.find(hql.toString(),DaiLuMap);
    }
    public void deleteById(Long id){

        super.delete(id);
    }
    public boolean update(GovdocLeaderPermissionRelation object){
        DBAgent.update(object);
        return true;
    }
    public boolean add(GovdocLeaderPermissionRelation object){
        DBAgent.save(object);
        return true;
    }
    public int check(String str1,String str2,String str3) {
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        DaiLuMap.put("orgAccountId", Long.valueOf(str1));
        DaiLuMap.put("leaderId", str2);
        DaiLuMap.put("category", Integer.valueOf(str3));
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where leaderId=:leaderId and category=:category and orgAccountId=:orgAccountId");
        List<GovdocLeaderPermissionRelation> list = DBAgent.find(hql.toString(), DaiLuMap);
        return list.size();
    }
    public int checkNew(String str1,String str2) {
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        DaiLuMap.put("orgAccountId", Long.valueOf(str1));
        DaiLuMap.put("leaderId", str2);
        //DaiLuMap.put("category", Integer.valueOf(str3));
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where leaderId=:leaderId and orgAccountId=:orgAccountId");
        List<GovdocLeaderPermissionRelation> list = DBAgent.find(hql.toString(), DaiLuMap);
        return list.size();
    }
    public boolean delete(String leaderId,Long orgAccountId,int category){
        List<GovdocLeaderPermissionRelation> list = findByIdAndOrgAccountId(leaderId,orgAccountId,category);
        DBAgent.deleteAll(list);
        return true;
    }
    public boolean deleteNew(String leaderId,Long orgAccountId){
        List<GovdocLeaderPermissionRelation> list = findByIdAndOrgAccountNewId(leaderId,orgAccountId);
        DBAgent.deleteAll(list);
        return true;
    }
    public List<GovdocLeaderPermissionRelation> findByIdAndOrgAccountNewId(String leaderId,Long orgAccountId){
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where leaderId=:leaderId ");
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        if(orgAccountId!=null) {
        	hql.append(" and orgAccountId=:orgAccountId");
        	DaiLuMap.put("orgAccountId", orgAccountId);
        }
        
        DaiLuMap.put("leaderId", leaderId);

        return DBAgent.find(hql.toString(),DaiLuMap);
    }
    
    public List<GovdocLeaderPermissionRelation> findByIdAndOrgAccountId(String leaderId,Long orgAccountId,int category){
        StringBuilder hql = new StringBuilder();
        hql.append("from GovdocLeaderPermissionRelation where leaderId=:leaderId ");
        Map<String, Object> DaiLuMap = new HashMap<String, Object>();
        if(orgAccountId!=null) {
        	hql.append(" and orgAccountId=:orgAccountId");
        	DaiLuMap.put("orgAccountId", orgAccountId);
        }
        
        DaiLuMap.put("leaderId", leaderId);

        return DBAgent.find(hql.toString(),DaiLuMap);
    }
    public void saveOrEdit(GovdocLeaderPermissionRelation govdocLPR){
        DBAgent.saveOrUpdate(govdocLPR);
    }
}
