package com.seeyon.apps.govdoc.dao;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.CopyUtils;

import com.seeyon.apps.edoc.bo.EdocSummaryFormDataBO;
import com.seeyon.ctp.common.dao.BaseHibernateDao;
import com.seeyon.ctp.util.DBAgent;
import com.seeyon.v3x.edoc.domain.EdocSummaryFormData;

public class GovdocSummaryFormDataDao extends BaseHibernateDao<EdocSummaryFormData> {

	public List<EdocSummaryFormDataBO> findAll(long formAppId, long formRecordId) {
		StringBuilder hql = new StringBuilder("from EdocSummaryFormData where formAppId =:formAppId and formRecordId=:formRecordId");
		Map<String, Long> conditions = new HashMap<String, Long>();
		conditions.put("formAppId", formAppId);
		conditions.put("formRecordId", formRecordId);
		List<EdocSummaryFormData> list =  DBAgent.find(hql.toString(), conditions);
		List<EdocSummaryFormDataBO> boList = new ArrayList<EdocSummaryFormDataBO>();
		if(!list.isEmpty()){
			for (EdocSummaryFormData data : list) {
				boList.add(data.toBo());
			}
		}
		return boList;
	}

	/**
	 * 查询value
	 * 
	 * @Author : xucb
	 * @Date : 2015年8月31日下午10:30:27
	 * @param conditions
	 * @return
	 */
	public void deleteData(EdocSummaryFormData data) {

		StringBuilder hql = new StringBuilder("delete from EdocSummaryFormData where 1=1 ");
		hql.append(" and formAppId=? ");
		hql.append(" and formRecordId=? ");
		hql.append(" and tableName=?");
		hql.append(" and fieldName=?");
		DBAgent.bulkUpdate(hql.toString(), data.getFormAppId(), data.getFormRecordId(), data.getTableName(),
				data.getFieldName());
	}
}
