package com.seeyon.apps.govdoc.listener;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.apps.govdoc.event.DealPishiEvent;
import com.seeyon.apps.govdoc.manager.GovdocTransInstructionManager;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.util.annotation.ListenEvent;

public class DealPishiEventListener {
	
	private static final Log LOGGER = LogFactory.getLog(DealPishiEventListener.class);
	private GovdocTransInstructionManager govdocTransInstructionManager;
	public void setGovdocTransInstructionManager(GovdocTransInstructionManager govdocTransInstructionManager) {
		this.govdocTransInstructionManager = govdocTransInstructionManager;
	}
	@ListenEvent(event=DealPishiEvent.class,async=true)
	public void onDealPishi(DealPishiEvent event) {
		//代录批示回调处理
		try {
			govdocTransInstructionManager.dealLeaderNode(event.getSummaryId(),event.getCurrentUserId());
		} catch (BusinessException e) {
			LOGGER.error("代录批示回调处理出现异常", e);
		}
	}
}
