package com.seeyon.apps.govdoc.listener;

import com.seeyon.apps.govdoc.event.GovdocAffairEvent;
import com.seeyon.apps.govdoc.manager.GovdocProcessManager;
import com.seeyon.apps.govdoc.vo.MemberPostVO;
import com.seeyon.ctp.common.AbstractSystemInitializer;
import com.seeyon.ctp.common.affair.manager.AffairManager;

import com.seeyon.ctp.common.content.affair.constants.SubStateEnum;
import com.seeyon.ctp.common.po.affair.CtpAffair;
import com.seeyon.ctp.event.EventDispatcher;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Seeyon on 2020-1-15.
 */
public class GovdocAffairListener extends AbstractSystemInitializer {
    private static Log LOGGER = LogFactory.getLog(GovdocAffairListener.class);
    private AffairManager affairManager;
    private GovdocProcessManager govdocProcessManager;

    public void setGovdocProcessManager(GovdocProcessManager govdocProcessManager) {
        this.govdocProcessManager = govdocProcessManager;
    }
    @Override
    public void initialize() {
        EventDispatcher.register(GovdocAffairEvent.class, "govdocAffairListener", "execute", true);
    }

    public void execute(GovdocAffairEvent event)
    {
        CtpAffair affair = event.getAffair();
        try{
            MemberPostVO memberPostVO = govdocProcessManager.getDefaultMemberPost(affair, event.getCurrentMember());
            if(memberPostVO != null)
            {
                Map<String, Object> columns = new HashMap<String, Object>();
                columns.put("matchAccountId", memberPostVO.getOrgAccountId());
                columns.put("matchDepartmentId", memberPostVO.getDepId());
                columns.put("matchPostId", memberPostVO.getPostId());
                Object[][] wheres = new Object[][] { { "id", affair.getId() }};
                affairManager.update(columns, wheres);

            }
        }
        catch (Exception e){
            LOGGER.error("事项预置落款错误", e);
        }

    }

    public AffairManager getAffairManager() {
        return affairManager;
    }

    public void setAffairManager(AffairManager affairManager) {
        this.affairManager = affairManager;
    }
}
