package com.seeyon.apps.govdoc.resourceManager;

import com.seeyon.ctp.common.i18n.ResourceUtil;

public class GovdocResourceEnum {
	/**
	 * 统计范围的enum
	 * @author chenx
	 *
	 */
	public enum ResourceMemberTypeEnums{
		currentMember,currentDepartment,poitTo
	}
	
	/**
	 * 包含老交换数据的分类
	 * 可以参考ApplicationSubCategoryEnum
	 * @author chenx
	 *
	 */
	public enum GovdocAffairSubAppIncludeOldExchangeEnums{
		sendGov("1,19","1,19,22","govdoc.edocSend.label"),//发文
		receiveGov("2,20","2,20,24,34","govdoc.edocRec.label"),//收文
		signGov("3,21","3,21","govdoc.edocSign.label"),//签报
		exchangeGov("4","4,23","govdoc.resource.resourceConfig.module.exchange");//交换
		
		private String key; //未包含交换类型的数据
		private String value;//包含交换类型的数据
		private String i18nName;
		
		GovdocAffairSubAppIncludeOldExchangeEnums(String key,String value,String i18nName){
			this.key = key;
			this.value = value;
			this.i18nName = i18nName;
		}
		
		public static GovdocAffairSubAppIncludeOldExchangeEnums findByKey(String key){
			for(GovdocAffairSubAppIncludeOldExchangeEnums e : GovdocAffairSubAppIncludeOldExchangeEnums.values()){
				if(e.getKey().equals(key)){
					return e;
				}
			}
			return null;
		}
		
		public String getText(){
			return ResourceUtil.getString(this.i18nName);
		}

		public String getKey() {
			return key;
		}

		public String getValue() {
			return value;
		}

	}
}
