package com.seeyon.apps.govdoc.resourceManager.vo;

import java.sql.Timestamp;
import java.util.Date;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.seeyon.apps.edoc.constants.EdocConstant;
import com.seeyon.apps.govdoc.manager.GovdocElementManager;
import com.seeyon.apps.govdoc.util.GovdocUtil;
import com.seeyon.apps.govdoc.vo.GovdocListVO;
import com.seeyon.ctp.common.content.affair.constants.StateEnum;
import com.seeyon.ctp.common.ctpenumnew.manager.EnumManager;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.po.ctpenumnew.CtpEnumBean;
import com.seeyon.ctp.common.po.ctpenumnew.CtpEnumItem;
import com.seeyon.ctp.common.taglibs.functions.Functions;
import com.seeyon.ctp.util.Strings;
import com.seeyon.v3x.edoc.domain.EdocElement;

public class GovdocResourceListVO extends GovdocListVO {
	/**
	 *  移动端必须的字段
	 */
	public static String NEEDED_FIELDS_4M = "summary.id," +
	        "summary.subject," +
	        "summary.identifier," +
	        "summary.govdocType," +
	        "summary.state," +
		   // "summary.isQuickSend," +
	        //"summary.templeteId," +
	        "summary.archiveId," +
	        "summary.processId," +
	        "summary.caseId," +
	        "summary.startUserId," +//11
	        "summary.startTime," +
	        "summary.createTime," +
	        "summary.completeTime," +
			//"summary.packTime," +
	        "summary.deadline," +
	        "summary.deadlineDatetime," + 
	        "summary.coverTime," +
		    "summary.docMark,"+
		    "summary.serialNo,"+
		    //"summary.docMark2,"+
		    "summary.docType,"+//21
		    "summary.sendType,"+
		    "summary.secretLevel,"+
		    "summary.urgentLevel,"+
		    "summary.unitLevel,"+
		    //"summary.keepPeriod,"+
		   // "summary.copies,"+
		   // "summary.issuer,"+
		    //"summary.signingDate,"+
		    //"summary.createPerson,"+
		    //"summary.printer,"+//31
		   // "summary.phone,"+
		    "summary.orgAccountId,"+
		    "summary.exchangeSendAffairId,"+
		    //"summary.undertaker," + 
		    //"summary.undertakenoffice," +
		    "summary.bodyType," +
		    "summary.hasArchive,"+
		    "summary.signPerson,"+
		    //"summary.receiptDate,"+
		    //"summary.registrationDate,"+//41
		    //"summary.fromType,"+
		    //"summary.newflowType";
			"affair.id," +
		    "affair.identifier,"+
		    //"affair.subject,"+
		    "affair.app,"+
		    "affair.subApp,"+
		    "affair.state," +
		    "affair.subState," +
		    "affair.finish," +
		    "affair.objectId,"+
		    "affair.subObjectId," +
		    "affair.activityId,"+
		    "affair.nodePolicy," +
		    "affair.memberId," +
		    //"affair.transactorId," +
		    
		    "affair.hastenTimes," +
		    "affair.coverTime," +
		    "affair.remindDate," +
		    "affair.deadlineDate," +
		    "affair.receiveTime," +
		    "affair.completeTime," +
		    //"affair.createDate," +
		    //"affair.updateDate," +
		    "affair.expectedProcessTime," +
		    "affair.importantLevel";
		    //"affair.archiveId,"+
		    //"affair.track," +
		    //"affair.backFromId,"+
		    //"affair.preApprover,"+
		    //"affair.proxyMemberId,"+
		    //"affair.transactorId,"+
		    //"affair.senderId";
	/**
     * 公文待办/已办/已发/待发列表/公文查询数据回填
     * @param object
     * @param hasDeduplication 是否包括Clob字段
     */
	public int toObject4M(Object[] object, boolean hasDeduplication) {
        int n = 0;
        this.setSummaryId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setSubject((String)object[n++]);
        this.setIdentifier((String)object[n++]);
        this.setGovdocType(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setSummaryState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        //this.setIsQuickSend((Boolean)object[n++]);
        //this.setTempleteId(object[n] == null ? null : ((Number) object[n]).longValue());
        //n++;
        this.setArchiveId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setProcessId((String)object[n++]);
        this.setCaseId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setStartUserId(object[n] == null ? null : ((Number) object[n]).longValue());//11
        n++;
        this.setStartTime((Timestamp)object[n++]);
        this.setCreateTime((Timestamp)object[n++]);
        this.setStartTime(this.getCreateTime());//兼容文单中有拟稿日期，start_time存的格式为2019-02-19 00:00:00
        this.setCompleteTime((Timestamp)object[n++]);
		//this.setPackTime((Timestamp)object[n++]);//分送日期
        this.setSummaryDeadline(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setSummaryDeadlineDatetime((Date)object[n++]);
        this.setSummaryIsCoverTime((Boolean)object[n++]);
        this.setDocMark((String)object[n++]);
        this.setSerialNo((String)object[n++]);
        //this.setSignMark((String)object[n++]);
        this.setDocType((String)object[n++]);//21
        this.setSendType((String)object[n++]);
        this.setSecretLevel((String)object[n++]);
        this.setUrgentLevel((String)object[n++]);
        this.setUnitLevel((String)object[n++]);
//        this.setKeepPeriod(object[n] == null ? null : ((Number) object[n]).intValue());
//        n++;
//        this.setCopies(object[n] == null ? null : ((Number) object[n]).intValue());
//        n++;
//        this.setIssuer((String)object[n++]);
//        this.setSigningDate((Date)object[n++]);
//        this.setCreatePerson((String)object[n++]);
//        this.setPrinter((String)object[n++]);//31
//        this.setPhone((String)object[n++]);
        this.setOrgAccountId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setExchangeSendAffairId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
//        this.setUndertaker((String)object[n++]);
//        this.setUndertakenoffice((String)object[n++]);
        String bodyType = (String)object[n++];
        if(Strings.isNotBlank(bodyType)) {
        	this.setContentType(GovdocUtil.getContentType(bodyType));
        }
        this.setHasArchive((Boolean)object[n++]);
        //增加签收时间和登记时间
        this.setSignPerson((String)object[n++]);
//        this.setReceiptDate((Date)object[n++]);
//        this.setRegistrationDate((Date)object[n++]);
//        this.setFromType(object[n] == null ? null : ((Number) object[n]).intValue());
//        n++;
//        Object autoRun = object[n++];
//        if(null != autoRun 
//        		&& (((Number) autoRun).intValue() == EdocConstant.NewflowType.child.ordinal()
//        		|| ((Number) autoRun).intValue() == EdocConstant.NewflowType.auto.ordinal())){
//            this.setAutoRun(true);
//        }
//        this.setAuditor((String)object[n++]);
//		this.setReview((String)object[n++]);
        //公文主表大字段
    	/*this.setCurrentNodesInfo((String)object[n++]);//41
    	this.setSendTo((String)object[n++]);
    	this.setCopyTo((String)object[n++]);
    	this.setReportTo((String)object[n++]);
    	this.setPrintUnit((String)object[n++]);
    	this.setSendUnit((String)object[n++]);
    	this.setSendDepartment((String)object[n++]);*/
    	//Affair表字段
        this.setAffairId(object[n] == null ? null : ((Number) object[n]).longValue()); 
        n++;
        this.setAffairIdentifier((String)object[n++]);
        //this.setAffairSubject((String)object[n++]);
        this.setAffairApp(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        Object o = object[n++];
        if(null != o){
        	 this.setAffairSubApp(((Number) o).intValue());
        }
        this.setAffairState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setAffairSubState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        o = object[n++];
        if(null != o){
        	this.setAffairFinish((Boolean)o);
        }
        this.setAffairObjectId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairSubObjectId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairActivityId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairNodePolicy((String)object[n++]);
        this.setAffairMemberId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
//        this.setAffairTransactorId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
        this.setAffairHastenTimes(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setAffairIsCoverTime((Boolean)object[n++]);
        this.setAffairRemindDate(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairDeadlineDate(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairReceiveTime((Date)object[n++]);
        this.setAffairCompleteTime((Date)object[n++]);
//        this.setAffairCreateDate((Date)object[n++]);
//        this.setAffairUpdateDate((Date)object[n++]);
        this.setAffairExpectedProcessTime((Date)object[n++]);
        //客开 项目名称： [修改功能：解决公文回退后，紧急程度图标丢失！] 作者：fzc 修改日期：2018-5-9 start
        n++;
        if (Strings.isNotEmpty(this.getUrgentLevel())) {
            this.setImportantLevel(Integer.valueOf(this.getUrgentLevel()));//importantLevel
        }else{
            this.setImportantLevel(1);//importantLevel
        }
//        //客开 项目名称： [修改功能：解决公文回退后，紧急程度图标丢失！] 作者：fzc 修改日期：2018-5-9 end
//        this.setAffairArchiveId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        this.setAffairTrack(object[n] == null ? null : ((Number) object[n]).intValue());
//        n++;
//        this.setAffairBackFromId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        this.setAffairPreApprover(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        this.setProxyMemberId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        this.setTransactorId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        this.setAffairSenderId(object[n] == null ? null : ((Number) object[n]).longValue());
//        n++;
//        o = object[n++];
//		if(o!=null){
//			this.setTurnRecUserId(((Number)o).longValue());
//		}
//        if(this.getExchangeSendAffairId()!=null&&this.getExchangeSendAffairId()!=-1){
//        	this.setExchangeSendAffairId(this.getAffairId());
//        }
        /*** bug OA-192165 中数据显示不一致问题 start ****/
        // 以affair里面的发起人为准
        if(this.getAffairSenderId() != null && this.getAffairSenderId() != -1) {
        	String memberName = Functions.showMemberName(this.getAffairSenderId());
        	this.setStartUserName(memberName);
        	this.setStartUserId(this.getAffairSenderId());
        }
        
        // 处理时间,与栏目保持一致已办没有处理时间时用接收时间
        if(this.getAffairCompleteTime() == null && 
        		StateEnum.col_done.getKey() == this.getAffairState()) {
        	this.setAffairCompleteTime(this.getAffairReceiveTime());
        }
        
        // 发起时间
        if(this.getAffairCreateDate() != null) {
        	this.setStartTime(getTimestamp(this.getAffairCreateDate()));
        }
        /*** bug OA-192165 中数据显示不一致问题 end ****/
        
        return n;
    }
	/**
	 *  PC浏览器必须的字段
	 */
	public static String NEEDED_FIELDS_4PC = "summary.id," +
	        "summary.subject," +
	        "summary.identifier," +
	        "summary.govdocType," +
	        "summary.state," +
		    "summary.isQuickSend," +
	        "summary.templeteId," +
	        "summary.archiveId," +
	        "summary.processId," +
	        "summary.caseId," +
	        "summary.startUserId," +//11
	        "summary.startTime," +
	        "summary.createTime," +
	        "summary.completeTime," +
			"summary.packTime," +
	        "summary.deadline," +
	        "summary.deadlineDatetime," + 
	        "summary.coverTime," +
		    "summary.docMark,"+
		    "summary.serialNo,"+
		    "summary.docMark2,"+
		    "summary.docType,"+//21
		    "summary.sendType,"+
		    "summary.secretLevel,"+
		    "summary.urgentLevel,"+
		    "summary.unitLevel,"+
		    "summary.keepPeriod,"+
		    "summary.copies,"+
		    "summary.issuer,"+
		    "summary.signingDate,"+
		    "summary.createPerson,"+
		    "summary.printer,"+//31
		    "summary.phone,"+
		    "summary.orgAccountId,"+
		    "summary.exchangeSendAffairId,"+
		    "summary.undertaker," + 
		    "summary.undertakenoffice," +
		    "summary.bodyType," +
		    "summary.hasArchive,"+
		    "summary.signPerson,"+
		    "summary.receiptDate,"+
		    "summary.registrationDate,"+//41
		    "summary.fromType,"+
		    "summary.newflowType,"+
		    "summary.auditor,"+
		    "summary.review,"+
//		    "summary.currentNodesInfo, "+ 
//		    "summary.sendTo, "+ 
//		    "summary.copyTo, "+ 
//		    "summary.reportTo, "+ 
//		    "summary.printUnit, "+ 
//		    "summary.sendUnit, "+ 
//		    "summary.sendDepartment,"+
			"affair.id," +
	        "affair.identifier,"+
	        "affair.subject,"+
	        "affair.app,"+
		    "affair.subApp,"+
	        "affair.state," +
	        "affair.subState," +
	        "affair.finish," +
	        "affair.objectId,"+
	        "affair.subObjectId," +
	        "affair.activityId,"+
	        "affair.nodePolicy," +
	        "affair.memberId," +
	        "affair.transactorId," +
	        
	        "affair.hastenTimes," +
	        "affair.coverTime," +
	        "affair.remindDate," +
	        "affair.deadlineDate," +
	        "affair.receiveTime," +
	        "affair.completeTime," +
	        "affair.createDate," +
	        "affair.updateDate," +
	        "affair.expectedProcessTime," +
	        "affair.importantLevel," +
		    "affair.archiveId,"+
	        "affair.track," +
		    "affair.backFromId,"+
		    "affair.preApprover,"+
		    "affair.proxyMemberId,"+
		    "affair.transactorId,"+
		    "affair.senderId,"+
		    "affair.turnRecUserId";
	
	public int toObject(Object[] object, boolean hasDeduplication,List<String> extendField,EnumManager enumManagerNew,GovdocElementManager elementManager) throws NumberFormatException, BusinessException{
		int n = this.toObject(object, hasDeduplication);
		//this.setPackTime((Date)object[n++]);
		return this.toExtendObj(n, object, extendField, enumManagerNew, elementManager);
	}
	
	/**
     * 公文待办/已办/已发/待发列表/公文查询数据回填
     * @param object
     * @param hasDeduplication 是否包括Clob字段
     */
	public int toObject(Object[] object, boolean hasDeduplication) {
        int n = 0;
        this.setSummaryId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setSubject((String)object[n++]);
        this.setIdentifier((String)object[n++]);
        this.setGovdocType(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setSummaryState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setIsQuickSend((Boolean)object[n++]);
        this.setTempleteId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setArchiveId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setProcessId((String)object[n++]);
        this.setCaseId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setStartUserId(object[n] == null ? null : ((Number) object[n]).longValue());//11
        n++;
        this.setStartTime((Timestamp)object[n++]);
        this.setCreateTime((Timestamp)object[n++]);
        this.setStartTime(this.getCreateTime());//兼容文单中有拟稿日期，start_time存的格式为2019-02-19 00:00:00
        this.setCompleteTime((Timestamp)object[n++]);
		this.setPackTime((Timestamp)object[n++]);//分送日期
        this.setSummaryDeadline(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setSummaryDeadlineDatetime((Date)object[n++]);
        this.setSummaryIsCoverTime((Boolean)object[n++]);
        this.setDocMark((String)object[n++]);
        this.setSerialNo((String)object[n++]);
        this.setSignMark((String)object[n++]);
        this.setDocType((String)object[n++]);//21
        this.setSendType((String)object[n++]);
        this.setSecretLevel((String)object[n++]);
        this.setUrgentLevel((String)object[n++]);
        this.setUnitLevel((String)object[n++]);
        this.setKeepPeriod(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setCopies(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setIssuer((String)object[n++]);
        this.setSigningDate((Date)object[n++]);
        this.setCreatePerson((String)object[n++]);
        this.setPrinter((String)object[n++]);//31
        this.setPhone((String)object[n++]);
        this.setOrgAccountId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setExchangeSendAffairId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setUndertaker((String)object[n++]);
        this.setUndertakenoffice((String)object[n++]);
        String bodyType = (String)object[n++];
        if(Strings.isNotBlank(bodyType)) {
        	this.setContentType(GovdocUtil.getContentType(bodyType));
        }
        this.setHasArchive((Boolean)object[n++]);
        //增加签收时间和登记时间
        this.setSignPerson((String)object[n++]);
        this.setReceiptDate((Date)object[n++]);
        this.setRegistrationDate((Date)object[n++]);
        this.setFromType(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        Object autoRun = object[n++];
        if(null != autoRun 
        		&& (((Number) autoRun).intValue() == EdocConstant.NewflowType.child.ordinal()
        		|| ((Number) autoRun).intValue() == EdocConstant.NewflowType.auto.ordinal())){
            this.setAutoRun(true);
        }
        this.setAuditor((String)object[n++]);
		this.setReview((String)object[n++]);
        //公文主表大字段
    	/*this.setCurrentNodesInfo((String)object[n++]);//41
    	this.setSendTo((String)object[n++]);
    	this.setCopyTo((String)object[n++]);
    	this.setReportTo((String)object[n++]);
    	this.setPrintUnit((String)object[n++]);
    	this.setSendUnit((String)object[n++]);
    	this.setSendDepartment((String)object[n++]);*/
    	//Affair表字段
        this.setAffairId(object[n] == null ? null : ((Number) object[n]).longValue()); 
        n++;
        this.setAffairIdentifier((String)object[n++]);
        this.setAffairSubject((String)object[n++]);
        this.setAffairApp(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        Object o = object[n++];
        if(null != o){
        	 this.setAffairSubApp(((Number) o).intValue());
        }
        this.setAffairState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setAffairSubState(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        o = object[n++];
        if(null != o){
        	this.setAffairFinish((Boolean)o);
        }
        this.setAffairObjectId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairSubObjectId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairActivityId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairNodePolicy((String)object[n++]);
        this.setAffairMemberId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairTransactorId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairHastenTimes(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setAffairIsCoverTime((Boolean)object[n++]);
        this.setAffairRemindDate(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairDeadlineDate(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairReceiveTime((Date)object[n++]);
        this.setAffairCompleteTime((Date)object[n++]);
        this.setAffairCreateDate((Date)object[n++]);
        this.setAffairUpdateDate((Date)object[n++]);
        this.setAffairExpectedProcessTime((Date)object[n++]);
        //客开 项目名称： [修改功能：解决公文回退后，紧急程度图标丢失！] 作者：fzc 修改日期：2018-5-9 start
        n++;
        if (Strings.isNotEmpty(this.getUrgentLevel())) {
            this.setImportantLevel(Integer.valueOf(this.getUrgentLevel()));//importantLevel
        }else{
            this.setImportantLevel(1);//importantLevel
        }
        //客开 项目名称： [修改功能：解决公文回退后，紧急程度图标丢失！] 作者：fzc 修改日期：2018-5-9 end
        this.setAffairArchiveId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairTrack(object[n] == null ? null : ((Number) object[n]).intValue());
        n++;
        this.setAffairBackFromId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairPreApprover(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setProxyMemberId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setTransactorId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        this.setAffairSenderId(object[n] == null ? null : ((Number) object[n]).longValue());
        n++;
        o = object[n++];
		if(o!=null){
			this.setTurnRecUserId(((Number)o).longValue());
		}
//        if(this.getExchangeSendAffairId()!=null&&this.getExchangeSendAffairId()!=-1){
//        	this.setExchangeSendAffairId(this.getAffairId());
//        }
        /*** bug OA-192165 中数据显示不一致问题 start ****/
        // 以affair里面的发起人为准
        if(this.getAffairSenderId() != null && this.getAffairSenderId() != -1) {
        	String memberName = Functions.showMemberName(this.getAffairSenderId());
        	this.setStartUserName(memberName);
        	this.setStartUserId(this.getAffairSenderId());
        }
        
        // 处理时间,与栏目保持一致已办没有处理时间时用接收时间
        if(this.getAffairCompleteTime() == null && 
        		StateEnum.col_done.getKey() == this.getAffairState()) {
        	this.setAffairCompleteTime(this.getAffairReceiveTime());
        }
        
        // 发起时间
        if(this.getAffairCreateDate() != null) {
        	this.setStartTime(getTimestamp(this.getAffairCreateDate()));
        }
        /*** bug OA-192165 中数据显示不一致问题 end ****/
        
        return n;
    }
	public Long turnRecUserId;//转办人
	private String  nibanyijian;//拟办意见

	public Long getTurnRecUserId() {
		return turnRecUserId;
	}

	public void setTurnRecUserId(Long turnRecUserId) {
		this.turnRecUserId = turnRecUserId;
	}
	
	
	public int toExtendObj(int startNum,Object[] obj,List<String> extendField,EnumManager enumManagerNew,GovdocElementManager elementManager) throws NumberFormatException, BusinessException{
		for(String field:extendField){
			Object o = obj[startNum++];
			String name = null;
			if(o!=null){
				if("summary.dealSuggestion".equals(field)){
					this.setNibanyijian((String)o);
				}else if("summary.sendUnit".equals(field)){
					this.setSendUnit((String)o);
				}else if("summary.sendTo".equals(field)){
					this.setSendTo((String)o);
				}else if("summary.copyTo".equals(field)){
					this.setCopyTo((String)o);
				}else if("summary.reportTo".equals(field)){
					this.setReportTo((String)o);
				}else if("summary.printUnit".equals(field)){
					this.setPrintUnit((String)o);
				}else if("summary.sendDepartment".equals(field)){
					this.setSendDepartment((String)o);
				}else if("summary.currentNodesInfo".equals(field)){
					this.setCurrentNodesInfo((String)o);
				}else{
					String id = o.toString();
					Pattern pattern = Pattern.compile("[-]{0,1}[0-9]*");
			        Matcher isNum = pattern.matcher(id);
			        field = field.substring(field.indexOf(".")+1);
					if(isNum.matches()){
						name = enumManagerNew.getEItemNameById(Long.parseLong(id));
						if(Strings.isBlank(name)){
							EdocElement element = elementManager.getByFieldName(field);
							if(element!=null && element.getMetadataId()!=null){
								CtpEnumBean enumBean = enumManagerNew.getEnum(element.getMetadataId());
								if(enumBean!=null){
									for(CtpEnumItem item:enumBean.getItems()){
										if(id.equals(item.getValue())){
											name = item.getShowvalue();
											break;
										}
									}
								}
							}
						}
					}else{
						name = id;
					}
					if("list1".equals(field)){
						this.setList1(name);
					}else if("list2".equals(field)){
						this.setList2(name);
					}else if("list3".equals(field)){
						this.setList3(name);
					}else if("list4".equals(field)){
						this.setList4(name);
					}else if("list5".equals(field)){
						this.setList5(name);
					}else if("list6".equals(field)){
						this.setList6(name);
					}else if("list7".equals(field)){
						this.setList7(name);
					}else if("list8".equals(field)){
						this.setList8(name);
					}else if("list9".equals(field)){
						this.setList9(name);
					}else if("list10".equals(field)){
						this.setList10(name);
					}else if("list11".equals(field)){
						this.setList11(name);
					}else if("list12".equals(field)){
						this.setList12(name);
					}else if("list13".equals(field)){
						this.setList13(name);
					}else if("list14".equals(field)){
						this.setList14(name);
					}else if("list15".equals(field)){
						this.setList15(name);
					}else if("list16".equals(field)){
						this.setList16(name);
					}else if("list17".equals(field)){
						this.setList17(name);
					}else if("list18".equals(field)){
						this.setList18(name);
					}else if("list19".equals(field)){
						this.setList19(name);
					}else if("list20".equals(field)){
						this.setList20(name);
					}
				}
				}
		}
		return startNum;
	}

	public String getNibanyijian() {
		return nibanyijian;
	}

	public void setNibanyijian(String nibanyijian) {
		this.nibanyijian = nibanyijian;
	}

}
